## Instalasi dan Penggunaan Web API
### Instalasi
1. Install python
2. Buka CMD atau Command-prompt
3. cd nama/folder/costapy (di copy)
4. Jalankan command ini di CMD:
   ```sh
   py -m pip install --upgrade pip
   py -m pip install bottle
   py -m pip install beaker
   py -m pip install mako
   py -m pip install mysql-connector
   py -m pip install bcrypt
   py -m pip install pyjwt[crypto]
   ```
5. Buka folder project pake VSCode
6. Buka file di config/server.py
7. servernya ganti dari 'gunicorn' ke 'wsgiref' (di save)
### Penggunaan
8. Buka CMD lalu jalanin service-nya: 
   - Untuk Windows:
   ```dos
   cd C:\direktori\folder\kamu
   py costa.py
   ```
   - Untuk Linux/MacOS:
   ```sh
   cd directory/folder/kamu
   python costapy
   ```
9. kalau keluar output http://localhost:11000 artinya berhasil
10. Install bruno
11. bikin collection
12. test localhost:11000
13. Praktek ke VSCode

## Instalasi dan Implementasi MariaDB

### Instalasi

- Windows: Download dari mariadb.org atau dari xampp lalu install
- Mac: Install melalui brew
- Debian/Ubuntu: sudo apt install mariadb-server
- Alternative lain: Pakai container (Docker)

### Penggunaan

- Terminal (Linux/MacOS): mariadb -u root -p
- MySQL Client Command Prompt: Buka MySQL client lalu masukan password

### Implementasi (Buat Table di dalam MySQL Client)

1. CREATE DATABASE latihan;
2. USE latihan;
3. CREATE TABLE member (
   id int(11) not null auto_increment primary key,
   name varchar(36) not null,
   phone varchar(14) null
   );
4. SHOW COLUMNS FROM member;
5. INSERT INTO member VALUES (
   DEFAULT, 
   'Nama_Kalian', 
   'Telp_Kalian'
   );
6. SELECT * FROM member;
7. exit

## Persiapan bagi yang ketinggalan sebelum jalanin Widuri Client
- Download Python [disini](https://www.python.org/downloads/) lalu install
- Selesaikan task Instalasi dan Implementasi MariaDB dulu
- Clone atau Download Widuri Client [disini](https://gitea.ditaajipratama.net/istek-widuri/widuri-client)
- Clone atau Download Widuri API [disini](https://gitea.ditaajipratama.net/istek-widuri/widuri-api)
- Buka CMD (Command-Prompt) lalu install kebutuhan library dengan command berikut: 
  - Untuk Linux/MacOS:
  ```sh
  cd directory/folder/widuri-api
  python -m pip install --upgrade pip
  python -m pip install bottle
  python -m pip install beaker
  python -m pip install mako
  python -m pip install mysql-connector
  python -m pip install bcrypt
  python -m pip install pyjwt[crypto]
  ```
  - Untuk Windows:
  ```dos
  cd C:\direktori\folder\widuri-api
  py -m pip install --upgrade pip
  py -m pip install bottle
  py -m pip install beaker
  py -m pip install mako
  py -m pip install mysql-connector
  py -m pip install bcrypt
  py -m pip install pyjwt[crypto]
  ```

## Pengunaan widuri-client
1. Buka Command-Prompt
2. Ke directory Widuri API (Contoh: `cd C:\direktori\widuri-api`)
3. Nyalain service Widuri API: `py costa.py`
4. Buka Command-Prompt baru
5. Ke directory Widuri Client (Contoh: `cd C:\direktori\widuri-client`)
6. Nyalain service Widuri Client: `py -m http.server 12000`
7. buka `localhost:12000` di Browser
